﻿using TFMAPI;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace Tests
{
    
    
    /// <summary>
    ///This is a test class for TwitterAPIWrapperTest and is intended
    ///to contain all TwitterAPIWrapperTest Unit Tests
    ///</summary>
    [TestClass()]
    public class TwitterAPIWrapperTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for GetUserFollowersInfo
        ///</summary>
        [TestMethod()]
        public void GetUserFollowersJSONTest()
        {
            //Get list of followers for an existing user
            string userScreenName = "jm_alarcon";    //"nonexistantbychance"; //A non existant one
            FollowersInfo res = TwitterAPIWrapper.GetUserFollowersInfo(userScreenName);
            Assert.IsInstanceOfType(res, typeof(FollowersInfo));

        }


        /// <summary>
        ///A test for GetTwitterUserInfo
        ///</summary>
        [TestMethod()]
        public void GetTwitterUserInfoTest()
        {
            string userScreenName = "jm_alarcon";
            TwitterUserInfo res = TwitterAPIWrapper.GetTwitterUserInfo(userScreenName);
            Assert.IsInstanceOfType(res, typeof(TwitterUserInfo));
        }

        /// <summary>
        ///A test for GetTwitterAPIQuota
        ///</summary>
        [TestMethod()]
        public void GetTwitterAPIQuotaTest()
        {
            rate_limit_status res = TwitterAPIWrapper.GetTwitterAPIQuota();
            Assert.IsInstanceOfType(res, typeof(rate_limit_status));
        }
    }
}
